//=============================================================================
//
//  CLASS DirectionalLight
//
//=============================================================================
#ifndef RAYTRACER_DIRECTIONALLIGHT_H
#define RAYTRACER_DIRECTIONALLIGHT_H

//== INCLUDES =================================================================
#include "Light.h"


//== CLASS DEFINITION =========================================================

/*!
	PointLight
*/
class DirectionalLight : public Light
{

    //-------------------------------------------------------------- private data
private:
    VectorType3 m_v3Direction;
    ColorType   m_colIntensity;


public:

    //-------------------------------------------------------------- constructors

    //! standard constructor
    DirectionalLight()
    {
    };

    //! initializing constructor
    DirectionalLight(
        const VectorType3   &v3Direction,   
        const ColorType     &colIntensity )  :
    m_v3Direction( v3Direction ),
    m_colIntensity( colIntensity )
    {
    };

    //! destructor	
    ~DirectionalLight()
    {
    };

    //----------------------------------------------------------- access elements
    void setDirection(
        const VectorType3   &v3Direction )  
    {
        m_v3Direction = v3Direction;
    };

    
    const VectorType3 &getDirection() const
    {
        return m_v3Direction;
    };

    
    void setIntensity(
        const ColorType &colIntensity ) 
    {
        m_colIntensity = colIntensity;
    };

    
    const ColorType &getIntensity() const
    {
        return m_colIntensity;
    };

    //----------------------------------------------------------- functionality
public:
    void    shadowFeeler( Ray             &clRay,
                          double        &rRayDomain,
                          ColorType       &colIntensity ) const;
    void    renderGL( GLint number ) const;
};
//=============================================================================
#endif // RAYTRACER_DIRECTIONALLIGHT_H
